$mod52

STD		EQU	P3.2

Q1			EQU	P3.6
Q2			EQU	P3.5
Q3			EQU	P3.4
Q4			EQU	P3.3

DIG7		EQU	P1.0
DIG3		EQU	P1.1
DIG6		EQU	P1.2
DIG9		EQU	P1.3
DIG5		EQU	P1.4
DIG8		EQU	P1.5
DIG4		EQU	P1.6
DIG1		EQU	P1.7
DIG2		EQU	P3.0
DIG0		EQU	P3.1

HOOK_SIM	EQU	P3.7

P_HOOK	EQU	P0.6

RING		EQU	P0.7

EDIT		EQU	P2.0
SENT		EQU	P2.1
SCROL		EQU	P2.2
CANCEL	EQU	P2.3

BUZZER	EQU	P2.4

KEYB_CLOCK	EQU	P2.7
KEYB_DATA	EQU	P2.6

; ***LCD CONTROL***
LCD_RS    EQU    P0.0     ;LCD REGISTER SELECT LINE
LCD_E     EQU    P0.1    ;LCD ENABLE LINE
LCD_DB4   EQU    P0.2     ;PORT 1 IS USED FOR DATA
LCD_DB5   EQU    P0.3     ;USED FOR DATA
LCD_DB6   EQU    P0.4    ;FOR DATA
LCD_DB7   EQU    P0.5     ;FOR DATA

; ***CURSOR CONTROL INSTRUCTIONS***

OFFCUR    EQU    0CH
BLINKCUR  EQU    0DH

; ***DISPLAY CONTROL INSTRUCTIONS***

CLRDSP    EQU    01H
ONDSP     EQU    0CH

; ***SYSTEM INSTRUCTIONS***

CONFIG    EQU    28H      ; 4-BIT DATA,2 LINES,5X7 MATRIX LCD
ENTRYMODE EQU    6        ; INCREMENT CURSOR DON'T SHIFT DISPLAY 

	 KB_LSHIFT	EQU      12H
	 KB_RSHIFT	EQU      59H
    KB_CTRL		EQU      14H
    KB_ALT		EQU      11H
    KB_CAPS		EQU      58H
    KB_SCROLL	EQU      7EH
    KB_NUML		EQU      77H
    KB_TAB		EQU      0DH
    KB_REL		EQU      0F0H
    KB_EXT		EQU      0E0H
    KB_PAUSE	EQU      0E1H

; For the stauts flags (KB_STATS)
    CAPS		EQU          01H
    NUML		EQU          02H
    SCROLL	EQU          04H
    SHIFT	EQU          08H
    ACK		EQU          10H
    CTRL		EQU          20H
    ALT		EQU          40H
    RELEASE	EQU        	 80H
; For the stauts flags 2 (KB_OK)
    PAUSED	EQU         40H
    EXTENDED EQU       80H



RB0     EQU     000H    ; Select Register Bank 0
RB1     EQU     008H    ; Select Register Bank 1  ...poke to PSW to use

WMCON DATA 96h ; watchdog and memory control register
EEMEN EQU 00001000b ; EEPROM access enable bit
EEMWE EQU 00010000b ; EEPROM write enable bit
WDTRST EQU 00000010b ; EEPROM RDY/BSY bit
DPS EQU 00000100b ; data pointer select bit

DSEG            ; This is internal data memory
ORG     20H     ; Bit adressable memory

FLAGS:	DS		1
A1 BIT    FLAGS.0
A2	BIT    FLAGS.1
A3 BIT    FLAGS.2
A4 BIT    FLAGS.3

CAPPS_ON:	DS		1
CAAPS	BIT	CAPPS_ON

KB_OK:		DS		1
KB_DATA:		DS		1
KB_STATS:		DS		1
KB_SCAN:		DS		1
KB_TEMP:		DS		1  ; For the da*n pause key
KB_COUNT:	DS		1

NUM1:		DS		1
NUM2:		DS		1
NUM3:		DS		1
NUM4:		DS		1
NUM5:		DS		1
NUM6:		DS		1
NUM7:		DS		1
NUM8:		DS		1
NUM9:		DS		1
NUM10:		DS		1
NUM11:		DS		1
NUM12:		DS		1
NUM13:		DS		1
NUM14:		DS		1
NUM15:		DS		1
NUM16:		DS		1


CHAR:			DS		1
CHAR1:			DS		1
CHAR2:			DS		1
DIAL_TEMP:		DS		1

stack:		DS		1
CSEG            ; Code begins here
         
;  ---------==========----------==========---------=========---------
;  Main routine. Program execution starts here.
;  ---------==========----------==========---------=========---------
			ORG     00H    ; Reset
START:	MOV SP,STACK
 			MOV PSW,#RB0
 			MOV P1,#00H
 			MOV P3,#00H
 			CLR CAAPS
			CLR BUZZER
 			CALL RESET_NUMBER
			CALL RESETLCD4					;reset LCD
			CALL INITLCD4

 		 	CALL TITLE1
			CALL DELAY
			CALL DELAY
			CALL DELAY
			CALL DELAY
			CALL NAME
			CALL DELAY
			CALL DELAY
			CALL DELAY
			CALL DELAY

			CALL NAME1
			CALL DELAY
			CALL DELAY
			CALL DELAY
			CALL DELAY
			CALL NAME2
			CALL DELAY
			CALL DELAY
			CALL DELAY
			CALL DELAY
			CALL NAME3
			CALL DELAY
			CALL DELAY
			CALL DELAY
			CALL DELAY
 			CLR HOOK_SIM
 		
 			
REPEAT1:	CLR HOOK_SIM
			MOV KB_COUNT,#00H
			CALL TITLE1

REPEAT:	SETB EDIT
			SETB P_HOOK
			SETB RING
						
			JNB EDIT,EDIT_TEXT1
			JNB P_HOOK,DISPLAY_NUM1
			JNB RING,RING_MONITOR
			AJMP REPEAT
;##########################################################
EDIT_TEXT1:
			AJMP EDIT_TEXT
DISPLAY_NUM1:
			AJMP DISPLAY_NUM

;##########################################################
;			CHECK FOR RING SIGNAL
;##########################################################
RING_MONITOR:
			JMP RING_RECEIVE
;##########################################################
;			SENTING SMS
;##########################################################
SENT_SMS:
		 CALL DISP4				;display enter the number
 		 MOV KB_COUNT,#00H
LOOPA: call   Check_Keyb			;check keyboard
	    SETB CANCEL
   	 JB CANCEL,ZXM7				;check cancel button
	    JNB CANCEL,$
   	 AJMP REPEAT1     
ZXM7:  SETB SENT
		 JB SENT,ZXM8				;check SENT button
	    JNB SENT,$
   	 JMP SENTING_SMS    
ZXM8:  JNC LoopA

		 MOV R7, KB_SCAN
	    CALL DECODING_NUM
	    MOV A,KB_COUNT
	    CJNE A,#01,GGK1
	    MOV NUM1,R7
GGK1:	 CJNE A,#02,GGK2
	    MOV NUM2,R7
GGK2:	 CJNE A,#03,GGK3
	    MOV NUM3,R7
GGK3:	CJNE A,#04,GGK4
	    MOV NUM4,R7
GGK4:	CJNE A,#05,GGK5
	    MOV NUM5,R7
GGK5:	CJNE A,#06,GGK6
	    MOV NUM6,R7
GGK6:	CJNE A,#07,GGK7
	    MOV NUM7,R7
GGK7:	CJNE A,#08,GGK8
	    MOV NUM8,R7
GGK8:	CJNE A,#09,GGK9
	    MOV NUM9,R7
GGK9:	CJNE A,#10,GGK10
	    MOV NUM10,R7
GGK10:	CJNE A,#11,GGK11
	    MOV NUM11,R7
GGK11:	CJNE A,#12,GGK12
	    MOV NUM12,R7
GGK12:	CJNE A,#13,GGK13
	    MOV NUM13,R7
GGK13:	CJNE A,#14,GGK14
	    MOV NUM14,R7
GGK14:	CJNE A,#15,GGK15
	    MOV NUM15,R7
GGK15:  CJNE A,#16,LOOPA
	    MOV NUM16,R7
	    
ZXMY:  SETB CANCEL
   	 JB CANCEL,ZXMT				;check cancel button
	    JNB CANCEL,$
   	 AJMP REPEAT1     
ZXMT:  SETB SENT
		 JB SENT,ZXMY				;check SENT button
	    JNB SENT,$
   	 JMP SENTING_SMS    
;##########################################################
SENTING_SMS:
		MOV A,KB_COUNT
		CJNE A,#00H,GBV2
		CALL DISP6
		CALL DELAY
		CALL DELAY
		AJMP SENT_SMS		
GBV2:	CALL DISP16			;display took the phone
		SETB P_HOOK
		MOV R3,#35H
AREL:	MOV R1,#0FFH
AR1A:	MOV R2,#0FFH
ARA:	JNB P_HOOK,XZR1						;wait for tooking phone
		DJNZ R2,ARA
		DJNZ R1,AR1A
		DJNZ R3,AREL
		AJMP REPPEAT1A
		
XZR1:	CALL DISP5			;display Dialling
		CALL DELAY
		CALL DELAY

		CALL DELAY
		CALL DELAY
		CALL DIAL_NUMBER	;dial number
		CALL DELAY
		CALL DELAY
		
		
		
		SETB STD
		SETB P_HOOK
		
		SETB CANCEL
		CALL DISP7							;display waiting for disp
		
		
			MOV R3,#90H
AEEL:		MOV R1,#0FFH
AE1A:		MOV R2,#0FFH
AEA:		JB STD,XZZ1						;wait for reply
			JB P_HOOK,NMN1
			DJNZ R2,AEA
			DJNZ R1,AE1A
			DJNZ R3,AEEL
NMN1:		AJMP REPPEAT1A
			
		
		
XZZ1:	CALL GET_NUMBER		
		MOV A,FLAGS
		CJNE A,#0AH,REPPEAT1A				
		CALL DISP8							;Display reply received
		CALL  RESET_NUMBER
		CALL DELAY
		JB STD,$
		CALL DELAY
		CALL DELAY
		SETB DIG0									;Replyin  0 
		CALL DELAY
		CLR DIG0	
		JB STD,$
		CALL DELAY
		CALL DELAY 
		CALL DISP9								;display transmitting msg
		MOV DPTR,#0050H
		ORL WMCON, #EEMEN 	 ; enable EEPROM accesses
		CALL DELAY
		CALL DELAY
		CALL DELAY
		CALL DELAY
NMNM1:MOVX A,@DPTR
		CJNE A,#0AAH,DHJH1
		CALL DELAY2							;DIAL 99 to indicate END of transmission
		SETB BUZZER
		SETB DIG9
		CALL DELAY2
		CLR DIG9
		CALL DELAY2 
		SETB DIG9
		CALL DELAY2
		CLR DIG9
		CALL DELAY2 
		XRL WMCON, #EEMEN	 		; disable EEPROM accesses
		CALL DISP10
		CALL DELAY
		CALL DELAY
		CLR HOOK_SIM
		CLR BUZZER
		AJMP REPEAT1
DHJH1:
		MOV R4,A
		CALL SENT_NUMBER
		CALL DELAY
		CALL DELAY
		INC DPTR
		AJMP NMNM1
		
	
	
		AJMP REPEAT1
;##########################################################		
REPPEAT1A:
			CLR HOOK_SIM
			CALL DISP14
			CALL DELAY
			CALL DELAY
			CALL DELAY
			CALL DISP15
			SETB SENT
			SETB CANCEL
JMJM1:	JNB CANCEL, REPPEAT1
			JB SENT,JMJM1
			AJMP SENTING_SMS
			
REPPEAT1:		
			AJMP REPEAT1
;##########################################################
;			DISPLAY THE DIALLED NUMBER
;##########################################################
DISPLAY_NUM:
		JB P_HOOK,REPPEAT1			;chk for Phone on/off hook
		CALL  DELAY
		CALL  DELAY
		JB P_HOOK,REPPEAT1	
		CALL DISP3					;Display plz dial
		SETB STD
		SETB STD
HGH1:	JB STD,UI1
		JB P_HOOK,DFD
		AJMP HGH1

UI1:	CALL GET_NUMBER		
		MOV A,FLAGS
		ADD A,#30H
		CJNE A,#3AH,TG1
		MOV A,#30H
TG1:	MOV R4,A
		CALL WRLCDDATA		;display the number on LCD
		SETB STD
		SETB P_HOOK
TTC:	JB STD,UI1
		JNB P_HOOK,TTC
DFD:	AJMP REPEAT1
;##########################################################
;		READ FOR DTMF IC
;##########################################################
GET_NUMBER:
		SETB Q1
		SETB Q2
		SETB Q3
		SETB Q4
		SETB STD
		MOV FLAGS,#00H
		JNB Q1,PP1
		SETB A1
PP1:	JNB Q2,PP2
		SETB A2
PP2:	JNB Q3,PP3
		SETB A3		
PP3:	JNB Q4,PP4
		SETB A4
PP4:	JB STD,$
		RET		
;##########################################################
;		DISPLAY ROUTINES
;##########################################################
TITLE1:
	MOV DPTR,#MSAG1
	CALL LCD_MSG
	RET
MSAG1:
	DB 1H,80H,'Msg Trans/Recep',0C0H,'Through Landline',00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DISP1:
	MOV DPTR,#MSG1
	CALL LCD_MSG
	RET
MSG1:
	DB 1H,84H,'Keyboard',0C3H,'* Not Ok *', 00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DISP2:
	MOV DPTR,#MSG2
	CALL LCD_MSG
	RET
MSG2:
	DB 1H,80H,00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DISP3:
	MOV DPTR,#MSG3
	CALL LCD_MSG
	RET
MSG3:
	DB 1H,80H,'Plz Dial...',0C0h,00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DISP4:
	MOV DPTR,#MSG4
	CALL LCD_MSG
	RET
MSG4:
	DB 1H,80H,'Enter the Number',0C0h,00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DISP5:
	MOV DPTR,#MSG5
	CALL LCD_MSG
	RET
MSG5:
	DB 1H,80H,'Please wait..',0C0H,'* Dialling.....* ', 00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DISP6:
	MOV DPTR,#MSG6
	CALL LCD_MSG
	RET
MSG6:
	DB 1H,80H,'Please enter the',0C0H,'* Phone Number *', 00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DISP7:
	MOV DPTR,#MSG7
	CALL LCD_MSG
	RET
MSG7:
	DB 1H,80H,'Waiting for',0C4H,'Reply...    ', 00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DISP8:
	MOV DPTR,#MSG8
	CALL LCD_MSG
	RET
MSG8:
	DB 1H,80H,'Reply Received..',00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DISP9:
	MOV DPTR,#MSG9
	CALL LCD_MSG
	RET
MSG9:
	DB 1H,80H,'Transmitting Msg',00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DISP10:
	MOV DPTR,#MSG10
	CALL LCD_MSG
	RET
MSG10:
	DB 1H,80H,'Msg Transmitted.',00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DISP11:
	MOV DPTR,#MSG11
	CALL LCD_MSG
	RET
MSG11:
	DB 1H,80H,'Receiving MSG',00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DISP12:
	MOV DPTR,#MSG12
	CALL LCD_MSG
	RET
MSG12:
	DB 1H,80H,'1 Msg Received..',0C2H,'Press SCROLL  ', 00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DISP13:
	MOV DPTR,#MSG13
	CALL LCD_MSG
	RET
MSG13:
	DB 1H,80H,'Phone Ringing...', 00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~:
DISP14:
	MOV DPTR,#MSG14
	CALL LCD_MSG
	RET
MSG14:
	DB 1H,80H,'Message Senting',0C2H,'** Failed **  ', 00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~:
DISP15:
	MOV DPTR,#MSG15
	CALL LCD_MSG
	RET
MSG15:
	DB 1H,80H,'Want to Retry?', 0C2H,'Press SENT    ', 00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~:
DISP16:
	MOV DPTR,#MSG16
	CALL LCD_MSG
	RET
MSG16:
	DB 1H,80H,'Plz take the', 0C4H,'Handset     ', 00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~:
NAME:
	MOV DPTR,#MSG17a
	CALL LCD_MSG
	RET
MSG17a:
	DB 1H,80H,'Project done by', 0C0H,'****************', 00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~:
NAME1:
	MOV DPTR,#MSG17
	CALL LCD_MSG
	RET
MSG17:
	DB 1H,85H,'JEYAN', 0C4H,'PATRICK', 00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~:
NAME2:
	MOV DPTR,#MSG18
	CALL LCD_MSG
	RET
MSG18:
	DB 1H,83H,'PASUPATHY', 0C6H,'LIJU', 00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~:
NAME3:
	MOV DPTR,#MSG19
	CALL LCD_MSG
	RET
MSG19:
	DB 1H,81H,'E&C Deparment', 0C3H,'2004-2005', 00H
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~:
DELAY:
		MOV R1,#0FFH
RE1:	MOV R2,#0FFH
RE:	NOP
		DJNZ R2,RE
		DJNZ R1,RE1
		RET
;##########################################################
;			KEYBOARD EDITING
;##########################################################
EDIT_TEXT:
		JNB EDIT,$
		MOV KB_COUNT,#00H
		MOV R4,#01H					;Clear Display
		CALL WRLCDCOM4
		MOV R4,#80H					;Point to first line
		CALL WRLCDCOM4
		MOV R4,#0FH					;Display on curser blinking
		CALL WRLCDCOM4
;##########################################################
		CALL InitKeyb				;Inizialize Keyboard 
      MOV a, KB_OK
      JZ KBNotOK
      
      XRL WMCON, #DPS ; switch data pointers
		MOV DPTR, #0050H			 ; address to write
		XRL WMCON, #DPS ; switch data pointers
		
Loop:
	     call   Check_Keyb			;check keyboard
	     SETB CANCEL
   	  JB CANCEL,ZXM1				;check cancel button
	     JNB CANCEL,$
   	  AJMP REPEAT1     
ZXM1:  	SETB SENT
			JB SENT,ZXM2				;check SENT button
		
		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		ORL WMCON, #EEMWE		 ; enable EEPROM writes	
		XRL WMCON, #DPS ; switch data pointers
		MOV A,#0AAH
		MOVX @DPTR,A			 ; write EEPROM
		INC DPTR
		XRL WMCON, #DPS ; switch data pointers
CZH1:	MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,CZH1		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
				
;########################################################## 
			JNB SENT,$
   	  JMP SENT_SMS    
ZXM2:  	
			JNC     Loop

			MOV R7, KB_SCAN
	    	CALL DECODING
	    	MOV CHAR,R7
;##########################################################
;			STORE IT IN EEPROM
;########################################################## 
	MOV A,KB_COUNT				;check for full count 
	CJNE A,#161,VCVC2
	AJMP LOOP
VCVC2:   	
     ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		ORL WMCON, #EEMWE		 ; enable EEPROM writes	
		MOV A, CHAR			 ; data to write
		XRL WMCON, #DPS ; switch data pointers
		MOVX @DPTR,A			 ; write EEPROM
		INC DPTR
		XRL WMCON, #DPS ; switch data pointers
C1H1:	MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,C1H1		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
				
;##########################################################    	
    	
    	MOV A,KB_COUNT
    	CJNE A,#16,HNB1				;SECOND Line
		MOV R4,#0C0H					;Fource Curser on Second Line
		CALL WRLCDCOM4
		AJMP LOOP   
;##########################################################        
KBNotOK:
		CALL DISP1
		SETB CANCEL
		JNB CANCEL,$
		ajmp REPEAT1
;##########################################################        		     
HNB1:	CJNE A,#32,HNB2				;THIRD line
		MOV R4,#01H						;Clear Display
		CALL WRLCDCOM4
		MOV R4,#80H					;Fource Curser on FIRST Line
		CALL WRLCDCOM4	
		AJMP LOOP        
		
HNB2:	CJNE A,#48,HNB3			;FOURTH line
		MOV R4,#0C0H					;Fource Curser on Second Line
		CALL WRLCDCOM4
		AJMP LOOP        
HNB3:	CJNE A,#64,HNB4			;FIFTH line
		MOV R4,#01H						;Clear Display
		CALL WRLCDCOM4
		MOV R4,#80H					;Fource Curser on FIRST Line
		CALL WRLCDCOM4  
		AJMP LOOP        
HNB4:	CJNE A,#80,HNB5			;SIXTH line
		MOV R4,#0C0H					;Fource Curser on Second Line
		CALL WRLCDCOM4
		AJMP LOOP        

HNB5:	CJNE A,#96,HNB6			;seven line
		MOV R4,#01H						;Clear Display
		CALL WRLCDCOM4
		MOV R4,#80H					;Fource Curser on FIRST Line
		CALL WRLCDCOM4  
		AJMP LOOP        
HNB6:	CJNE A,#112,HNB7			;eighth line
		MOV R4,#0C0H					;Fource Curser on Second Line
		CALL WRLCDCOM4
		AJMP LOOP        

HNB7:	CJNE A,#128,HNB8			;NINE line
		MOV R4,#01H						;Clear Display
		CALL WRLCDCOM4
		MOV R4,#80H					;Fource Curser on FIRST Line
		CALL WRLCDCOM4  
		AJMP LOOP        
HNB8:	CJNE A,#144,HNB9			;TEN line
		MOV R4,#0C0H					;Fource Curser on Second Line
		CALL WRLCDCOM4
		AJMP LOOP 
		
HNB9:	CJNE A,#160,HNB10			;NINE line
		MOV R4,#01H						;Clear Display
		CALL WRLCDCOM4
		MOV R4,#80H					;Fource Curser on FIRST Line
		CALL WRLCDCOM4  
		AJMP LOOP        
HNB10:	CJNE A,#176,HNB11			;TEN line
		MOV R4,#0C0H					;Fource Curser on Second Line
		CALL WRLCDCOM4
		AJMP LOOP 

HNB11:	CJNE A,#192,HNB12			;NINE line
		MOV R4,#01H						;Clear Display
		CALL WRLCDCOM4
		MOV R4,#80H					;Fource Curser on FIRST Line
		CALL WRLCDCOM4  
		AJMP LOOP        
HNB12:	CJNE A,#208,HNB13			;TEN line
		MOV R4,#0C0H					;Fource Curser on Second Line
		CALL WRLCDCOM4
		AJMP LOOP 
		
HNB13:	CJNE A,#224,HNB14			;NINE line
		MOV R4,#01H						;Clear Display
		CALL WRLCDCOM4
		MOV R4,#80H					;Fource Curser on FIRST Line
		CALL WRLCDCOM4  
		AJMP LOOP        
HNB14:	CJNE A,#240,HNB15			;TEN line
		MOV R4,#0C0H					;Fource Curser on Second Line
		CALL WRLCDCOM4
		AJMP LOOP 
		
HNB15:	CJNE A,#253,HNB16			;NINE line
		MOV R4,#01H						;Clear Display
		CALL WRLCDCOM4
		MOV R4,#80H					;Fource Curser on FIRST Line
		CALL WRLCDCOM4  
HNB16:AJMP LOOP        
	
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;			decode phone number
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
DECODING_NUM:
	CJNE R7,#70H,SSDX1			;check for numbers
	MOV R4,#'0'
	CALL WRLCDDATA
	MOV R7,#00
	INC KB_COUNT
	RET
SSDX1:	CJNE R7,#69H,SSDX2			
	MOV R4,#'1'
	CALL WRLCDDATA
	MOV R7,#01
	INC KB_COUNT
	RET
SSDX2:	CJNE R7,#72H,SSDX3
	MOV R4,#'2'
	CALL WRLCDDATA
	MOV R7,#02
	INC KB_COUNT
	RET
SSDX3:	CJNE R7,#7AH,SSDX4			
	MOV R4,#'3'
	CALL WRLCDDATA
	MOV R7,#03
	INC KB_COUNT
	RET
SSDX4:	CJNE R7,#6BH,SSDX5			
	MOV R4,#'4'
	CALL WRLCDDATA	
	MOV R7,#04
	INC KB_COUNT
	RET
SSDX5:	CJNE R7,#73H,SSDX6			
	MOV R4,#'5'
	CALL WRLCDDATA	
	MOV R7,#05
	INC KB_COUNT
	RET
SSDX6:	CJNE R7,#74H,SSDX7			
	MOV R4,#'6'
	CALL WRLCDDATA
	MOV R7,#06
	INC KB_COUNT
	RET
SSDX7:	CJNE R7,#6CH,SSDX8			
	MOV R4,#'7'
	CALL WRLCDDATA	
	MOV R7,#07
	INC KB_COUNT
	RET
SSDX8:	CJNE R7,#75H,SSDX9			
	MOV R4,#'8'
	CALL WRLCDDATA
	MOV R7,#08
	INC KB_COUNT
	RET
SSDX9:	CJNE R7,#7DH,SSDX10			
	MOV R4,#'9'
	CALL WRLCDDATA
	MOV R7,#09
	INC KB_COUNT
SSDX10:	RET
;##########################################################



DECODING:
	
	MOV A,KB_COUNT				;check for full count 
	CJNE A,#254,VCVC1
	RET
VCVC1:
	CJNE R7,#29H,SXS1			;check for SPACE
	MOV R4,#' '
	CALL WRLCDDATA
	MOV R7,#40H					;40 FOR SPACE
	INC KB_COUNT
	RET
SXS1:	CJNE R7,#66H,SXS2			;check for BACK SPACE
	MOV R4,#04H					
	CALL WRLCDCOM4
	INC KB_COUNT
	RET
SXS2:
	CJNE R7,#70H,SXSDA1			;check for numbers
	MOV R4,#'0'
	CALL WRLCDDATA
	MOV R7,#00
	INC KB_COUNT
	RET
SXSDA1:	CJNE R7,#69H,SXSD2			
	MOV R4,#'1'
	CALL WRLCDDATA
	MOV R7,#01
	INC KB_COUNT
	RET
SXSD2:	CJNE R7,#72H,SXSD3
	MOV R4,#'2'
	CALL WRLCDDATA
	MOV R7,#02
	INC KB_COUNT
	RET
SXSD3:	CJNE R7,#7AH,SXSD4			
	MOV R4,#'3'
	CALL WRLCDDATA
	MOV R7,#03
	INC KB_COUNT
	RET
SXSD4:	CJNE R7,#6BH,SXSD5			
	MOV R4,#'4'
	CALL WRLCDDATA	
	MOV R7,#04
	INC KB_COUNT
	RET
SXSD5:	CJNE R7,#73H,SXSD6			
	MOV R4,#'5'
	CALL WRLCDDATA	
	MOV R7,#05
	INC KB_COUNT
	RET
SXSD6:	CJNE R7,#74H,SXSD7			
	MOV R4,#'6'
	CALL WRLCDDATA
	MOV R7,#06
	INC KB_COUNT
	RET
SXSD7:	CJNE R7,#6CH,SXSD8			
	MOV R4,#'7'
	CALL WRLCDDATA	
	MOV R7,#07
	INC KB_COUNT
	RET
SXSD8:	CJNE R7,#75H,SXSD9			
	MOV R4,#'8'
	CALL WRLCDDATA
	MOV R7,#08
	INC KB_COUNT
	RET
SXSD9:	CJNE R7,#7DH,SXSD10			
	MOV R4,#'9'
	CALL WRLCDDATA
	MOV R7,#09
	INC KB_COUNT
	RET

SXSD10:	;JNB CAAPS,SMMALL
	CJNE R7,#45H,SSD1			;check for numbers
	MOV R4,#'0'
	CALL WRLCDDATA
	MOV R7,#00
	INC KB_COUNT
	RET
;SMMALL:	JMP SMALL
SSD1:	CJNE R7,#16H,SSD2			
	MOV R4,#'1'
	CALL WRLCDDATA	
	MOV R7,#01
	INC KB_COUNT
	RET
SSD2:	CJNE R7,#1EH,SSD3
	MOV R4,#'2'
	CALL WRLCDDATA	
	MOV R7,#02
	INC KB_COUNT
	RET
SSD3:	CJNE R7,#26H,SSD4			
	MOV R4,#'3'
	CALL WRLCDDATA	
	MOV R7,#03
	INC KB_COUNT
	RET
SSD4:	CJNE R7,#25H,SSD5			
	MOV R4,#'4'
	CALL WRLCDDATA	
	MOV R7,#04
	INC KB_COUNT
	RET
SSD5:	CJNE R7,#2EH,SSD6			
	MOV R4,#'5'
	CALL WRLCDDATA	
	MOV R7,#05
	INC KB_COUNT
	RET
SSD6:	CJNE R7,#36H,SSD7			
	MOV R4,#'6'
	CALL WRLCDDATA	
	MOV R7,#06
	INC KB_COUNT
	RET
SSD7:	CJNE R7,#3DH,SSD8			
	MOV R4,#'7'
	CALL WRLCDDATA	
	MOV R7,#07
	INC KB_COUNT
	RET
SSD8:	CJNE R7,#3EH,SSD9			
	MOV R4,#'8'
	CALL WRLCDDATA	
	MOV R7,#08
	INC KB_COUNT
	RET
SSD9:	CJNE R7,#46H,SSD10			
	MOV R4,#'9'
	CALL WRLCDDATA	
	MOV R7,#09
	INC KB_COUNT
	RET

SSD10:CJNE R7,#1CH,SD1			; capital letter
	MOV R4,#'A'
	CALL WRLCDDATA	
	MOV R7,#10H
	INC KB_COUNT
	RET

SD1:	CJNE R7,#32H,SD2
	MOV R4,#'B'
	CALL WRLCDDATA	
	MOV R7,#11H
	INC KB_COUNT
	RET
SD2:	CJNE R7,#21H,SD3
	MOV R4,#'C'
	CALL WRLCDDATA	
	MOV R7,#12H
	INC KB_COUNT
		RET
SD3:	CJNE R7,#23H,SD4
	MOV R4,#'D'
	CALL WRLCDDATA	
	MOV R7,#13H
	INC KB_COUNT
	RET
SD4:	CJNE R7,#24H,SD5
	MOV R4,#'E'
	CALL WRLCDDATA	
	MOV R7,#14H
	INC KB_COUNT
	RET
SD5:	CJNE R7,#2BH,SD6
	MOV R4,#'F'
	CALL WRLCDDATA	
	MOV R7,#15H
	INC KB_COUNT
	RET
SD6:	CJNE R7,#34H,SD7
	MOV R4,#'G'
	CALL WRLCDDATA
	MOV R7,#16H
	INC KB_COUNT
	RET
SD7:	CJNE R7,#33H,SD8
	MOV R4,#'H'
	CALL WRLCDDATA	
	MOV R7,#17H
	INC KB_COUNT
	RET
SD8:	CJNE R7,#43H,SD9
	MOV R4,#'I'
	CALL WRLCDDATA
	MOV R7,#18H
	INC KB_COUNT
	RET
SD9:	CJNE R7,#3BH,SD10
	MOV R4,#'J'
	CALL WRLCDDATA	
	MOV R7,#19H
	INC KB_COUNT
	RET
SD10:	CJNE R7,#42H,SD11
	MOV R4,#'K'
	CALL WRLCDDATA	
	MOV R7,#20H
	INC KB_COUNT
	RET
SD11:	CJNE R7,#4BH,SD12
	MOV R4,#'L'
	CALL WRLCDDATA	
	MOV R7,#21H
	INC KB_COUNT
	RET
SD12:	CJNE R7,#3AH,SD13
	MOV R4,#'M'
	CALL WRLCDDATA	
	MOV R7,#22H 
	INC KB_COUNT
	RET
SD13:	CJNE R7,#31H,SD14
	MOV R4,#'N'
	CALL WRLCDDATA	
	MOV R7,#23H
	INC KB_COUNT
	RET
SD14:	CJNE R7,#44H,SD15
	MOV R4,#'O'
	CALL WRLCDDATA	
	MOV R7,#24H
	INC KB_COUNT
	RET
SD15:	CJNE R7,#4DH,SD16
	MOV R4,#'P'
	CALL WRLCDDATA	
	MOV R7,#25H
	INC KB_COUNT
	RET
SD16:	CJNE R7,#15H,SD18
	MOV R4,#'Q'
	CALL WRLCDDATA
	MOV R7,#26H
	INC KB_COUNT
	RET
SD18:	CJNE R7,#2DH,SD19
	MOV R4,#'R'
	CALL WRLCDDATA	
	MOV R7,#27H
	INC KB_COUNT
	RET
SD19:	CJNE R7,#1BH,SD20
	MOV R4,#'S'
	CALL WRLCDDATA	
	MOV R7,#28H
	INC KB_COUNT
	RET
SD20:	CJNE R7,#2CH,SD21
	MOV R4,#'T'
	CALL WRLCDDATA	
	MOV R7,#29H
	INC KB_COUNT
	RET
SD21:	CJNE R7,#3CH,SD22
	MOV R4,#'U'
	CALL WRLCDDATA
	MOV R7,#30H
	INC KB_COUNT
	RET
SD22:	CJNE R7,#2AH,SD23
	MOV R4,#'V'
	CALL WRLCDDATA	
	MOV R7,#31H
	INC KB_COUNT
		RET
SD23:	CJNE R7,#1DH,SD24
	MOV R4,#'W'
	CALL WRLCDDATA	
	MOV R7,#32H
	INC KB_COUNT
	RET
SD24:	CJNE R7,#22H,SD25
	MOV R4,#'X'
	CALL WRLCDDATA
	MOV R7,#33H
	INC KB_COUNT
	RET
SD25:	CJNE R7,#35H,SD26
	MOV R4,#'Y'
	CALL WRLCDDATA
	MOV R7,#34H
	INC KB_COUNT
	RET
SD26:	CJNE R7,#1AH,SD27
	MOV R4,#'Z'
	CALL WRLCDDATA	
	MOV R7,#35H
	INC KB_COUNT
	RET

SD27:	RET

SMALL:
		RET


;---------------------
; Keyboard Routines:
;---------------------
;*************************************
; WaitKB: Wait for keypress
;*************************************
WaitKB:
        call   Check_Keyb
        jnc     WaitKB
        ret
;*************************************
; InitKeyb: c=1 if ACK OK
;*************************************
CheckACK:
        mov     a, KB_STATS
        mov     c, acc.4
        clr     acc.4
        mov     KB_STATS, a
        ret

;*************************************
; InitKeyb:
;*************************************
InitKeyb:
        mov     KB_TEMP, #0
        mov     KB_OK, #0
        mov     r1, #0FFH
        call   Write_Keyb
        call   Check_Keyb
        call   CheckACK
        jnc     InitKeyb

        mov     r1, #0F4H       ; Enable
       call   Write_Keyb
        call   Check_Keyb
        call   CheckACK
        jnc     KeybErr

        mov     r1, #0F3H       ; Set Typematic
        call   Write_Keyb
        call   Check_Keyb
        call   CheckACK
        jnc     KeybErr
        mov     r1, #00H      ; Typematic = 250 ms / 30 cps
        call   Write_Keyb
        call   Check_Keyb
        call   CheckACK
        jnc     KeybErr

        mov     KB_OK, #1
        mov     KB_STATS, #2    ; Num Lock ON

;*************************************
; Keyb_Leds: Set KB_STATS as leds
;*************************************
Keyb_Leds:
        mov     r1, #0EDH       ; Set Leds
        call   Write_Keyb
        call   Check_Keyb
        call   CheckACK
        jnc     KeybErr
        mov     r1, KB_STATS
        call   Write_Keyb
        call   Check_Keyb
        call   CheckACK
KeybErr:
        ret
;*************************************
; Zero2One: Wait for 0 to 1 on kb
; clock line, read the kb data line
; and shift right the bit to acc.7
;*************************************
Zero2One:
        jnb     KEYB_CLOCK, $
        jb      KEYB_CLOCK, $
        mov     c, KEYB_DATA
        rrc     a
        ret

;*************************************
; Check_Keyb: Check to see if any key
; are pressed or release, returns
; ASCII codes on KB_DATA, or 1 for
; special keys, 2 for same special
; with shift. Return also the scan
; code on KB_SCAN.
; Special Keys are basicaly all non
; printable keys. See the table below
; all 1 and 2 returned are special keys
;*************************************
Check_Keyb:
        setb    KEYB_DATA
        setb    KEYB_CLOCK              ; CLOCK &amp; DATA high = Idle Pos
        mov     r0, #50                 
CheckAgain:
        jnb     KEYB_CLOCK, KeyHit
        djnz    r0, CheckAgain          ; check r0 times
        sjmp    KeyEnd
KeyHit:
        jnb     KEYB_DATA, KeyHit2      ; Start bit must be 0
KeyEnd:
        clr     KEYB_CLOCK              ; disable keyb
        clr     c                       ; c=0 = no keypress
        ret
KeyHit2:
        mov     r0, #8          ; 8 bits
        clr     a
KeyHit3:
        acall   Zero2One
        djnz    r0, KeyHit3
        mov     r1, a

        clr     a
        acall   Zero2One        ; Parity bit
        acall   Zero2One        ; Stop bit
        ; acc.7 = stop, acc.6 = parity
        clr     KEYB_CLOCK

        mov     a, KB_TEMP
        jz      NoIgnore        
        dec     KB_TEMP         ; Igonre pause scans
        sjmp    ChkKbEndNC

NoIgnore:
        mov     KB_SCAN, r1

        cjne    r1, #0FAH, NoKbACK
        orl     KB_STATS, #ACK
        sjmp    ChkKbEndNC

NoKbACK:
        cjne    r1, #KB_PAUSE, NoKbPause
        mov     KB_TEMP, #7             ; Ignore next 7 scans
        mov     a, KB_OK
        cpl     acc.6
        mov     KB_OK, a
        sjmp    ChkKbEndNC

NoKbPause:
        cjne    r1, #KB_EXT, NoKbExt
        orl     KB_OK, #EXTENDED
        sjmp    ChkKbEndNC

NoKbExt:
        cjne    r1, #KB_REL, NoRelease
        orl     KB_STATS, #RELEASE
        sjmp    ChkKbEndNC

NoRelease:
; Test Num lock, if pressed toggle led
        cjne    r1, #KB_NUML, NoNumLock
        mov     a, KB_STATS
        jnb     acc.7, ChkKbEndNC
        cpl     acc.1
        clr     acc.7
        mov     KB_STATS, a
        call   Keyb_Leds
        sjmp    ChkKbEndNC

NoNumLock:
; Test Caps lock, if pressed toggle led
        cjne    r1, #KB_CAPS, NoCapsLock
        mov     a, KB_STATS
        jnb     acc.7, ChkKbEndNC
        cpl     acc.2
        clr     acc.7
        mov     KB_STATS, a
        call   Keyb_Leds
        sjmp    ChkKbEndNC

NoCapsLock:
; Test Scroll lock, if pressed toggle led
        cjne    r1, #KB_SCROLL, NoScrollLock
        mov     a, KB_STATS
        jnb     acc.7, ChkKbEndNC
        cpl     acc.0
        clr     acc.7
        mov     KB_STATS, a
        call   Keyb_Leds
ChkKbEndNC:
        clr     c
        ret

NoScrollLock:
; Test L &amp; R shifts, set bit if pressed, clear on release
        cjne    r1, #KB_LSHIFT, NoShift1
ShiftOK:
        mov     a, KB_STATS
        jbc     acc.7, ShiftRel
        setb    acc.3           ; not releasing, so Set SHIFT bit
        sjmp    ShiftEnd
ShiftRel:
        clr     acc.3           ; releasing, so Clear SHIFT bit
ShiftEnd:
        mov     KB_STATS, a
        sjmp    ChkKbEndNC      
NoShift1:
        cjne    r1, #KB_RSHIFT, NoShift
        sjmp    ShiftOK

NoShift:
        cjne    r1, #KB_CTRL, NoCtrl
        mov     a, KB_STATS
        jbc     acc.7, CtrlRel
        setb    acc.5           ; not releasing, so Set CTRL bit
        sjmp    CtrlEnd
CtrlRel:
        clr     acc.5           ; releasing, so Clear SHIFT bit
CtrlEnd:
        mov     KB_STATS, a
        sjmp    ChkKbEndNC      

NoCtrl:
        cjne    r1, #KB_ALT, NoAlt
        mov     a, KB_STATS
        jbc     acc.7, AltRel
        setb    acc.6           ; not releasing, so Set ALT bit
        sjmp    AltEnd
AltRel:
        clr     acc.6           ; releasing, so Clear ALT bit
AltEnd:
        mov     KB_STATS, a
        sjmp    ChkKbEndNC      

NoAlt:
        mov     a, KB_STATS             ; Releasing key test
        jnb     acc.7, NoRel2           
        clr     acc.7                   ; if releasing &gt; clear
        mov     KB_STATS, a             ; rel bit on KB_STATS
        clr     c                       ; and do nothing 
        ret
NoRel2:
        mov     a, KB_OK                ; Extended key test
        jnb     acc.7, KbChars           
        clr     acc.7                   ; if Extended &gt; clear
        mov     KB_OK, a                ; EXT bit on KB_OK
        clr     c                       ; and do nothing 
        ret
KbChars:mov     dptr, #KbScanCodes
        mov     a, KB_STATS
        jnb     acc.2, TestShift
        jb      acc.3, KbChkOK
        mov     a, r1
        movc    a, @a+dptr
        mov     r0, a
        subb    a, #97
        jc      KbChkOK
        mov     a, r0
        subb    a, #123
        jnc     KbChkOK
        mov     dptr, #KbScanCodes2     ; if (a to z) &amp; Caps &gt; table 2
        sjmp    KbChkOK
TestShift:
        jnb     acc.3, KbChkOK
        mov     dptr, #KbScanCodes2     ; with shift table 2
KbChkOK:
        mov     a, r1
        movc    a, @a+dptr
        mov     KB_DATA, a
        setb    c
        
        ret

;*************************************
; Zero2One2: Wait for high to low in
; kb clock line
;*************************************
Zero2One2:
        jnb     KEYB_CLOCK, $
        jb      KEYB_CLOCK, $
        ret
;*************************************
; Write_Keyb: Send r1 to the kb
;*************************************
Write_Keyb:
        mov     r0, #8          ; 8 bits to receive
        clr     KEYB_CLOCK      ; break the Keyboard
        mov	r7, #00H       ; some delay (safety reasons)
_WKwait:djnz	r7, _WKwait
        clr     KEYB_DATA       ; request to send
        setb    KEYB_CLOCK      ; enable the Keyboard
        acall   Zero2One2       ; Start Bit
        mov     a, r1           ; Data Bits
TxData:
        rrc     a
        mov     KEYB_DATA, c
        call   Zero2One2
        djnz    r0, TxData

        mov     a, r1           ; calculate parity bit
        mov     c, psw.0        ; this is Even parity
        cpl     c               ; and Keyboard needs Odd parity
        mov     KEYB_DATA, c    ; send parity bit
        call   Zero2One2

        setb    KEYB_DATA       ; send stop bit
        call   Zero2One2

        call   Zero2One2
        mov     c, KEYB_DATA    ; get ACK bit
        clr     KEYB_CLOCK      ; stop the keyboard     
        ret
;**********************************************************
; INITIALIZE THE LCD 4-BIT MODE                                                                                   
;**********************************************************
INITLCD4:
         CLR         LCD_RS     ; LCD REGISTER SELECT LINE
         CLR         LCD_E      ; ENABLE LINE
         MOV         R4, #CONFIG; FUNCTION SET - DATA BITS,
                                ; LINES, FONTS
         CALL       WRLCDCOM4
         MOV         R4, #ONDSP ; DISPLAY ON
         CALL       WRLCDCOM4
         MOV         R4, #ENTRYMODE ; SET ENTRY MODE
         CALL       WRLCDCOM4  ; INCREMENT CURSOR RIGHT, NO SHIFT
         MOV         R4, #CLRDSP; CLEAR DISPLAY, HOME CURSOR
         CALL       WRLCDCOM4
         RET
; **********************************************************
; SOFTWARE VERSION OF THE POWER ON RESET
; **********************************************************
RESETLCD4:
         CLR         LCD_RS     ; LCD REGISTER SELECT LINE
         CLR         LCD_E      ; ENABLE LINE
         CLR         LCD_DB7    ; SET BIT PATTERN FOR...
         CLR         LCD_DB6    ; ... POWER-ON-RESET
         SETB        LCD_DB5
         SETB        LCD_DB4
         SETB        LCD_E      ; START ENABLE PULSE
         CLR         LCD_E      ; END ENABLE PULSE
         MOV         A, #4      ; DELAY 4 MILLISECONDS
         CALL       MDELAY
         SETB        LCD_E      ; START ENABLE PULSE
         CLR         LCD_E      ; END ENABLE PULSE
         MOV         A, #1      ; DELAY 1 MILLISECOND
         CALL       MDELAY
         SETB        LCD_E      ; START ENABLE PULSE
         CLR         LCD_E      ; END ENABLE PULSE
         MOV         A, #1      ; DELAY 1 MILLISECOND
         CALL       MDELAY
         CLR         LCD_DB4    ; SPECIFY 4-BIT OPERATION
         SETB        LCD_E      ; START ENABLE PULSE
         CLR         LCD_E      ; END ENABLE PULSE
         MOV         A, #1      ; DELAY 1 MILLISECOND
         CALL       MDELAY
         MOV         R4, #CONFIG; FUNCTION SET
         CALL       WRLCDCOM4
         MOV         R4, #08H   ; DISPLAY OFF
         CALL       WRLCDCOM4
         MOV         R4, #1     ; CLEAR DISPLAY, HOME CURSOR
         CALL       WRLCDCOM4
         MOV         R4,#ENTRYMODE  ; SET ENTRY MODE
         ACALL       WRLCDCOM4
 	   JMP INITLCD4

; **********************************************************
; SUB WRITES A COMMAND WORD TO THE LCD
; COMMAND MUST BE PLACED IN R4 BY CALLING PROGRAM
; **********************************************************
WRLCDCOM4:
         CLR         LCD_E
         CLR         LCD_RS     ; SELECT SEND COMMAND
         PUSH        ACC        ; SAVE ACCUMULATOR
         MOV         A, R4      ; PUT DATA BYTE IN ACC
         MOV         C, ACC.4   ; LOAD HIGH NIBBLE ON DATA BUS
         MOV         LCD_DB4, C ; ONE BIT AT A TIME USING...
         MOV         C, ACC.5   ; BIT MOVE OPERATOINS
         MOV         LCD_DB5, C
         MOV         C, ACC.6
         MOV         LCD_DB6, C
         MOV         C, ACC.7
         MOV         LCD_DB7, C
         SETB        LCD_E      ; PULSE THE ENABLE LINE
         CLR         LCD_E
         MOV         C, ACC.0   ; SIMILARLY, LOAD LOW NIBBLE
         MOV         LCD_DB4, C
         MOV         C, ACC.1
         MOV         LCD_DB5, C
         MOV         C, ACC.2
         MOV         LCD_DB6, C
         MOV         C, ACC.3
         MOV         LCD_DB7, C
         CLR         LCD_E
         SETB        LCD_E      ; PULSE THE ENABLE LINE
         CLR         LCD_E
         CALL MADELAY
         POP         ACC
         RET
; **********************************************************
; SUB TO WRITE A DATA WORD TO THE LCD
; DATA MUST BE PLACED IN R4 BY CALLING PROGRAM
; **********************************************************
WRLCDDATA:
         CLR         LCD_E
         SETB        LCD_RS     ; SELECT SEND DATA
         PUSH        ACC        ; SAVE ACCUMULATOR
         MOV         A, R4      ; PUT DATA BYTE IN ACC
         MOV         C, ACC.4   ; LOAD HIGH NIBBLE ON DATA BUS
         MOV         LCD_DB4, C ; ONE BIT AT A TIME USING...
         MOV         C, ACC.5   ; BIT MOVE OPERATOINS
         MOV         LCD_DB5, C
         MOV         C, ACC.6
         MOV         LCD_DB6, C
         MOV         C, ACC.7
         MOV         LCD_DB7, C
         SETB        LCD_E      ; PULSE THE ENABLE LINE
         CLR         LCD_E
         MOV         C, ACC.0   ; SIMILARLY, LOAD LOW NIBBLE
         MOV         LCD_DB4, C
         MOV         C, ACC.1
         MOV         LCD_DB5, C
         MOV         C, ACC.2
         MOV         LCD_DB6, C
         MOV         C, ACC.3
         MOV         LCD_DB7, C
         CLR         LCD_E
         SETB        LCD_E      ; PULSE THE ENABLE LINE
         CLR         LCD_E
         NOP
         NOP
         POP         ACC
         RET

; **********************************************************
; SUB TAKES THE STRING IMMEDIATELY FOLLOWING THE CALL AND
; DISPLAYS ON THE LCD. STRING MUST BE TERMINATED WITH A
; NULL (0).
; **********************************************************
LCD_MSG:
	CLR A			; Clear Index 
	MOVC A,@A+DPTR		; Get byte pointed by Dptr 
	INC DPTR			; Point to the next byte 
	JZ LCD_Msg9		; Return if found the zero (end of stringz) 
        CJNE A,#001H,Lcd_Msg1	; Check if is a Clear Command 
	MOV R4,A
	CALL WRLCDCOM4       	;If yes, write it as command to LCD 
	JMP   LCD_MSG          	;Go get next byte from stringz 
                              
Lcd_Msg1: CJNE A,#0FFH,FLL	;Check for displaying full character
	MOV R4,A
	CALL WRLCDDATA
	JMP LCD_MSG
 FLL:	CJNE  A,#080h,$+3      	; Data or Address?  If => 80h then is address. 
	JC    Lcd_Msg_Data     	; Carry will be set if A < 80h (Data) 
	MOV R4,A
	CALL  WRLCDCOM4         ; Carry not set if A=>80, it is address 
	JMP Lcd_Msg          	; Go get next byte from stringz 
                             
Lcd_Msg_Data:                   ; 
	MOV R4,A
	CALL WRLCDDATA        	; It was data, write it to Lcd 
	JMP  Lcd_Msg          		; Go get next byte from stringz 
Lcd_Msg9: 
	
	RET                    	; Return to Caller 



; **********************************************************
; 1 MILLISECOND DELAY ROUTINE
; **********************************************************

MDELAY:
         PUSH        ACC
         MOV         A,#0A6H
MD_OLP:
         INC         A
         NOP
         NOP
         NOP
         NOP
         NOP
         NOP
         NOP
         NOP
         JNZ         MD_OLP
         NOP
         POP         ACC
         RET
MADELAY:
         PUSH        ACC
         MOV         A,#036H
MAD_OLP:
         INC         A
         NOP
         NOP
         NOP
         NOP
         NOP
         NOP
         NOP
         NOP
         JNZ         MAD_OLP
         NOP
         POP         ACC
         RET
;#######################################################
;			ROUTINE TO DIAL THE NUMBER
;#######################################################
DIAL_NUMBER:
			MOV A,NUM1
			CJNE A,#0FFH,DIAL1
			RET
DIAL1:	CALL DIALS
			MOV A,NUM2
			CJNE A,#0FFH,DIAL2
			RET
DIAL2:	CALL DIALS
			MOV A,NUM3
			CJNE A,#0FFH,DIAL3
			RET
DIAL3:	CALL DIALS
			MOV A,NUM4
			CJNE A,#0FFH,DIAL4
			RET
DIAL4:	CALL DIALS
			MOV A,NUM5
			CJNE A,#0FFH,DIAL5
			RET
DIAL5:	CALL DIALS
			MOV A,NUM6
			CJNE A,#0FFH,DIAL6
			RET
DIAL6:	CALL DIALS
			MOV A,NUM7
			CJNE A,#0FFH,DIAL7
			RET
DIAL7:	CALL DIALS
			MOV A,NUM8
			CJNE A,#0FFH,DIAL8
			RET
DIAL8:	CALL DIALS
			MOV A,NUM9
			CJNE A,#0FFH,DIAL9
			RET
DIAL9:	CALL DIALS
			MOV A,NUM10
			CJNE A,#0FFH,DIAL10
			RET
DIAL10:	CALL DIALS
			MOV A,NUM11
			CJNE A,#0FFH,DIAL11
			RET
DIAL11:	CALL DIALS
			MOV A,NUM12
			CJNE A,#0FFH,DIAL12
			RET
DIAL12:	CALL DIALS
			MOV A,NUM13
			CJNE A,#0FFH,DIAL13
			RET
DIAL13:	CALL DIALS
			MOV A,NUM14
			CJNE A,#0FFH,DIAL14
			RET
DIAL14:	CALL DIALS
			MOV A,NUM15
			CJNE A,#0FFH,DIAL15
			RET
DIAL15:	CALL DIALS
			MOV A,NUM16
			CJNE A,#0FFH,DIAL16
			RET
DIAL16:	CALL DIALS
			RET
;#######################################################
;			SENTING THE CHARACTERS
;#######################################################
SENT_NUMBER:
			MOV A,R4
			SWAP A
			ANL A,#0FH
			CALL SENT_CHAR
			MOV A,R4
			CALL DELAY2
			ANL A,#0FH
			CALL SENT_CHAR
			RET
			
SENT_CHAR:
			
			CJNE A,#00H,KL0
			SETB DIG0
			CALL DELAY2
			CLR DIG0
			RET
KL0:		CJNE A,#01H,KL11
			SETB DIG1
			CALL DELAY2
			CLR DIG1
			RET
KL11:		CJNE A,#01H,KL1
			SETB DIG1
			CALL DELAY2
			CLR DIG1
			RET
KL1:		CJNE A,#02H,KL2
			SETB DIG2
			CALL DELAY2
			CLR DIG2
			RET
KL2:		CJNE A,#03H,KL3
			SETB DIG3
			CALL DELAY2
			CLR DIG3
			RET
KL3:		CJNE A,#04H,KL4
			SETB DIG4
			CALL DELAY2
			CLR DIG4
			RET
KL4:		CJNE A,#05H,KL5
			SETB DIG5
			CALL DELAY2
			CLR DIG5
			RET
KL5:		CJNE A,#06H,KL6
			SETB DIG6
			CALL DELAY2
			CLR DIG6
			RET
KL6:		CJNE A,#07H,KL7
			SETB DIG7
			CALL DELAY2
			CLR DIG7
			RET
KL7:		CJNE A,#08H,KL8
			SETB DIG8
			CALL DELAY2
			CLR DIG8
			RET
KL8:		CJNE A,#09H,KL9
			SETB DIG9
			CALL DELAY2
			CLR DIG9
KL9:		RET

;#######################################################
;			DIAL THE NUMBER STORED IN A
;#######################################################		
DIALS:
		CJNE A,#00H,FVC0
		SETB DIG0
		CALL DELAY2
		CLR DIG0
		CALL DELAY2
		RET
FVC0:	CJNE A,#01H,FVC1
		SETB DIG1
		CALL DELAY2
		CLR DIG1
		CALL DELAY2
		RET
FVC1:	CJNE A,#02H,FVC2
		SETB DIG2
		CALL DELAY2
		CLR DIG2
		CALL DELAY2
		RET
FVC2:	CJNE A,#03H,FVC3
		SETB DIG3
		CALL DELAY2
		CLR DIG3
		CALL DELAY2
		RET  
FVC3:	CJNE A,#04H,FVC4
		SETB DIG4
		CALL DELAY2
		CLR DIG4
		CALL DELAY2
		RET       
FVC4:	CJNE A,#05H,FVC5
		SETB DIG5
		CALL DELAY2
		CLR DIG5
		CALL DELAY2
		RET
FVC5:	CJNE A,#06H,FVC6
		SETB DIG6
		CALL DELAY2
		CLR DIG6
		CALL DELAY2
		RET
FVC6:	CJNE A,#07H,FVC7
		SETB DIG7 
		CALL DELAY2
		CLR DIG7
		CALL DELAY2
		RET 
FVC7:	CJNE A,#08H,FVC8
		SETB DIG8
		CALL DELAY2
		CLR DIG8
		CALL DELAY2
		RET
FVC8:	CJNE A,#09H,FVC9
		SETB DIG9
		CALL DELAY2
		CLR DIG9
		CALL DELAY2
FVC9:	RET

;#######################################################
;
;#######################################################
DELAY2:
		MOV R1,#0AFH
RE1x:	MOV R2,#0FFH
REx:	NOP
		DJNZ R2,REx
		DJNZ R1,RE1x
		RET		
;#######################################################
;					RING RECEIVE PROGRAM
;#######################################################
RING_RECEIVE:
			SETB BUZZER
			CALL DISP13
		   SETB P_HOOK
		   MOV R3,#100
RE2Z:		MOV R1,#0FFH
RE1Z:		MOV R2,#0FFH
REZ:		JNB P_HOOK,PLOP			;wait for off hook
			DJNZ R2,REZ
			DJNZ R1,RE1Z
			DJNZ R3,RE2Z
REPPEATES:JMP REPEAT1	
		   
PLOP:		CLR BUZZER
			CALL DELAY
			CALL DELAY
			CALL DELAY
			CALL DELAY
			SETB DIG0
			CALL DELAY2
			CLR DIG0	
			CALL DELAY2
			JB STD,$
			
			
			CALL DISP7					;Waiting for Reply
			MOV R3,#0AH
REEL:		MOV R1,#0FFH
RE1A:		MOV R2,#0FFH
REA:		JB STD,PLOP1
			DJNZ R2,REA
			DJNZ R1,RE1A
			DJNZ R3,REEL
			JMP REPEAT1

			
			SETB STD 
			SETB CANCEL	
XZZ9:		JNB CANCEL,REPPEATES
			JNB STD,XZZ9						;wait for reply
PLOP1:	CALL GET_NUMBER	
			MOV A,FLAGS
			CJNE A,#0AH,REPPEATES				;check if 0 dialed
			XRL WMCON, #DPS ; switch data pointers
			MOV DPTR, #0500H			 ; address to write
			XRL WMCON, #DPS ; switch data pointers
			CALL DISP11							;Display Receiving MSG
			SETB HOOK_SIM
RECEIVE_CHAR:
			SETB CANCEL	
XFZ9:		JNB CANCEL,REPPEATEZ
			JNB STD,XFZ9						
			CALL GET_NUMBER					;GET LSB OF CHAR
			MOV A,FLAGS
			CJNE A,#0AH,TG1F
			MOV A,#00H			
TG1F:		MOV CHAR1,A							;Save it
			
			SETB STD								;get MSB of char
XZZS:		JNB CANCEL,REPPEATE
			JNB STD,XZZS						;wait for reply
			CALL GET_NUMBER		
			MOV A,FLAGS
			CJNE A,#0AH,TG1V
			MOV A,#00H			
TG1V:		MOV CHAR2,A
			MOV A,CHAR2
			SWAP A
			ORL A,CHAR1
			CJNE A,#99H,EEPROM_DISPLAY		;Store it in EEPROM
			
			 ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		ORL WMCON, #EEMWE		 ; enable EEPROM writes	
		XRL WMCON, #DPS ; switch data pointers
		MOV A,#0AAH		
		MOVX @DPTR,A			 ; write EEPROM
		INC DPTR
		XRL WMCON, #DPS ; switch data pointers
CvH1:	MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,CvH1		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		CLR BUZZER
		CALL DISP12
		CLR HOOK_SIM
		SETB BUZZER
		SETB CANCEL
		SETB SCROL
FAS1:	JNB CANCEL,SXSXSSX2
		JB SCROL,FAS1
		CLR BUZZER
		AJMP EEPROMDISP			;read from EEprom and display
SXSXSSX2:
		CLR BUZZER
		JMP REPPEATE	;											DISPLAY_TEXT 					;receiving finished
			
REPPEATEZ:
		AJMP REPPEATE			
EEPROM_DISPLAY:
 		ORL  WMCON, #EEMEN		 ; enable EEPROM accesses
		ORL WMCON, #EEMWE		 ; enable EEPROM writes	
		XRL WMCON, #DPS ; switch data pointers
		SWAP A
		MOVX @DPTR,A			 ; write EEPROM
		INC DPTR
		XRL WMCON, #DPS ; switch data pointers
CuH1:	MOV A,WMCON			;Check for eeprom finished or not
		JNB ACC.1,CuH1		 ; jump if data compare fails (busy)
		XRL WMCON, #EEMWE		 ; disable EEPROM writes
		XRL WMCON, #EEMEN		 ; disable EEPROM accesses
		AJMP RECEIVE_CHAR		
		
		
;#######################################################
REPPEATE:
		JMP REPPEAT1
				
;#######################################################
;			READ FROM EEPROM AND DISPLAY
;#######################################################
EEPROMDISP:
			MOV DPTR,#0500H
			MOV KB_COUNT,#00H
			MOV R4,#01H					;Clear Display
		CALL WRLCDCOM4
		MOV R4,#80H					;Point to first line
		CALL WRLCDCOM4
		MOV R4,#0CH					;Display on curser OFF
		CALL WRLCDCOM4
			
			ORL WMCON, #EEMEN 	 ; enable EEPROM accesses
GBGB1:	MOVX A,@DPTR
			CJNE A,#0AAH,XCX2
			XRL WMCON, #EEMEN	 ; disable EEPROM accesses
			SETB CANCEL
			SETB SCROL	
			JNB SCROL,EEPROMDISP		
			JB CANCEL,$
			JMP REPEAT1
			
XCX2:		CALL DISPLAY_LCD
			INC DPTR        			
			MOV A,KB_COUNT
    	CJNE A,#16,HZB1				;SECOND Line
		MOV R4,#0C0H					;Fource Curser on Second Line
		CALL WRLCDCOM4
		AJMP LOOP5        		     
HZB1:	CJNE A,#32,HZB2				;THIRD line
		MOV R4,#01H						;Clear Display
		CALL WRLCDCOM4
		MOV R4,#80H					;Fource Curser on FIRST Line
		CALL WRLCDCOM4	
		AJMP LOOP5        
		
HZB2:	CJNE A,#48,HZB3			;FOURTH line
		MOV R4,#0C0H					;Fource Curser on Second Line
		CALL WRLCDCOM4
		AJMP LOOP5        
HZB3:	CJNE A,#64,HZB4			;FIFTH line
		MOV R4,#01H						;Clear Display
		CALL WRLCDCOM4
		MOV R4,#80H					;Fource Curser on FIRST Line
		CALL WRLCDCOM4  
		AJMP LOOP5        
HZB4:	CJNE A,#80,HZB5			;SIXTH line
		MOV R4,#0C0H					;Fource Curser on Second Line
		CALL WRLCDCOM4
		AJMP LOOP5       

HZB5:	CJNE A,#96,HZB6			;seven line
		MOV R4,#01H						;Clear Display
		CALL WRLCDCOM4
		MOV R4,#80H					;Fource Curser on FIRST Line
		CALL WRLCDCOM4  
		AJMP LOOP5        
HZB6:	CJNE A,#112,HZB7			;eighth line
		MOV R4,#0C0H					;Fource Curser on Second Line
		CALL WRLCDCOM4
		AJMP LOOP5       

HZB7:	CJNE A,#128,HZB8			;NINE line
		MOV R4,#01H						;Clear Display
		CALL WRLCDCOM4
		MOV R4,#80H					;Fource Curser on FIRST Line
		CALL WRLCDCOM4  
		AJMP LOOP5        
HZB8:	CJNE A,#144,HZB9			;TEN line
		MOV R4,#0C0H					;Fource Curser on Second Line
		CALL WRLCDCOM4
		AJMP LOOP5 

HZB9:	CJNE A,#160,HZB10			;NINE line
		MOV R4,#01H						;Clear Display
		CALL WRLCDCOM4
		MOV R4,#80H					;Fource Curser on FIRST Line
		CALL WRLCDCOM4  
		AJMP LOOP5        
HZB10:	CJNE A,#176,HZB11			;TEN line
		MOV R4,#0C0H					;Fource Curser on Second Line
		CALL WRLCDCOM4
		AJMP LOOP5 

HZB11:	CJNE A,#192,HZB12			;NINE line
		MOV R4,#01H						;Clear Display
		CALL WRLCDCOM4
		MOV R4,#80H					;Fource Curser on FIRST Line
		CALL WRLCDCOM4  
		AJMP LOOP5        
HZB12:	CJNE A,#208,HZB13			;TEN line
		MOV R4,#0C0H					;Fource Curser on Second Line
		CALL WRLCDCOM4
		AJMP LOOP5 

HZB13:	CJNE A,#224,HZB14			;NINE line
		MOV R4,#01H						;Clear Display
		CALL WRLCDCOM4
		MOV R4,#80H					;Fource Curser on FIRST Line
		CALL WRLCDCOM4  
		AJMP LOOP5        
HZB14:	CJNE A,#240,HZB15			;TEN line
		MOV R4,#0C0H					;Fource Curser on Second Line
		CALL WRLCDCOM4
		AJMP LOOP5 

HZB15:	CJNE A,#253,HZB16			;NINE line
		MOV R4,#01H						;Clear Display
		CALL WRLCDCOM4
		MOV R4,#80H					;Fource Curser on FIRST Line
		CALL WRLCDCOM4  
HZB16:AJMP LOOP5        
	
			
LOOP5:	CALL DELAY
			AJMP GBGB1
;#######################################################
DISPLAY_LCD:
			CJNE A,#00H,JKL0
			MOV R4,#'0'
			CALL WRLCDDATA
			INC KB_COUNT
			RET	
JKL0:		CJNE A,#01H,JKL1
			MOV R4,#'1'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL1:		CJNE A,#02H,JKL2
			MOV R4,#'2'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL2:		CJNE A,#03H,JKL3
			MOV R4,#'3'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL3:		CJNE A,#04H,JKL4
			MOV R4,#'4'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL4:		CJNE A,#05H,JKL5
			MOV R4,#'5'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL5:		CJNE A,#06H,JKL6
			MOV R4,#'6'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL6:		CJNE A,#07H,JKL7
			MOV R4,#'7'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL7:		CJNE A,#08H,JKL8
			MOV R4,#'8'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL8:		CJNE A,#09H,JKL9
			MOV R4,#'9'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL9:		CJNE A,#40H,JKL10
			MOV R4,#' '
			CALL WRLCDDATA
			INC KB_COUNT 
			RET
JKL10:	CJNE A,#10H,JKL1F
			MOV R4,#'A'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL1F:	CJNE A,#11H,JKL11
			MOV R4,#'B'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL11:	CJNE A,#12H,JKL12
			MOV R4,#'C'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL12:	CJNE A,#13H,JKL13
			MOV R4,#'D'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL13:	CJNE A,#14H,JKL14
			MOV R4,#'E'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL14:	CJNE A,#15H,JKL15
			MOV R4,#'F'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL15:	CJNE A,#16H,JKL16
			MOV R4,#'G'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL16:	CJNE A,#17H,JKL17
			MOV R4,#'H'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL17:	CJNE A,#18H,JKL18
			MOV R4,#'I'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL18:	CJNE A,#19H,JKL19
			MOV R4,#'J'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL19:	CJNE A,#20H,JKL20
			MOV R4,#'K'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL20:	CJNE A,#21H,JKL21
			MOV R4,#'L'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL21:	CJNE A,#22H,JKL22
			MOV R4,#'M'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL22:	CJNE A,#23H,JKL23
			MOV R4,#'N'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL23:	CJNE A,#24H,JKL24
			MOV R4,#'O'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL24:	CJNE A,#25H,JKL25
			MOV R4,#'P'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL25:	CJNE A,#26H,JKL26
			MOV R4,#'Q'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL26:	CJNE A,#27H,JKL27
			MOV R4,#'R'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL27:	CJNE A,#28H,JKL28
			MOV R4,#'S'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL28:	CJNE A,#29H,JKL29
			MOV R4,#'T'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL29:	CJNE A,#30H,JKL30
			MOV R4,#'U'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL30:	CJNE A,#31H,JKL31
			MOV R4,#'V'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL31:	CJNE A,#32H,JKL32
			MOV R4,#'W'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL32:	CJNE A,#33H,JKL33
			MOV R4,#'X'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL33:	CJNE A,#34H,JKL34
			MOV R4,#'Y'
			CALL WRLCDDATA
			INC KB_COUNT
			RET
JKL34:	CJNE A,#35H,JKL35
			MOV R4,#'Z'
			CALL WRLCDDATA
			INC KB_COUNT
JKL35:	RET



;#######################################################
 RESET_NUMBER:
 			MOV NUM1,#0FFH
 			MOV NUM2,#0FFH
 			MOV NUM3,#0FFH
 			MOV NUM4,#0FFH
 			MOV NUM5,#0FFH
 			MOV NUM6,#0FFH
 			MOV NUM7,#0FFH
 			MOV NUM8,#0FFH
 			MOV NUM9,#0FFH
 			MOV NUM10,#0FFH
 			MOV NUM11,#0FFH
 			MOV NUM12,#0FFH
 			MOV NUM13,#0FFH
 			MOV NUM14,#0FFH
 			MOV NUM15,#0FFH
 			MOV NUM16,#0FFH
 			RET
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; last 262 addr of code mem with scan codes tables
org    1200H
KbScanCodes:
; Keyboard Scancodes
;       ?,  F9, ?,  F5,  F4,  F1,  F2, F12, ?, F10,  F8,  F6,  F4, TAB,  ~
db     0,  1 , 0,  1 ,  1 ,  1 ,  1 ,  1 , 0,  1 ,  1 ,  1 ,  1 ,  1 , '~'
;       ?, ?,Lalt,Lshf, ?,Lctr,  Q ,  ! , ?, ?, ?,  Z ,  S ,  A ,  W ,  @
db     0, 0,  0 ,  0 , 0,  0 , 'q', '1', 0, 0, 0, 'z', 's', 'a', 'w', '2'
;       ?, ?,  C ,  X ,  D ,  E ,  $ ,  # , ?, ?, " ",  V ,  F ,  T ,  R
db     0, 0, 'c', 'x', 'd', 'e', '4', '3', 0, 0, ' ', 'v', 'f', 't', 'r'
;       % , ?, ?,  N ,  B ,  H ,  G ,  Y ,  ^ , ?, ?, ?,  M ,  J ,  U ,  &
db    '5', 0, 0, 'n', 'b', 'h', 'g', 'y', '6', 0, 0, 0, 'm', 'j', 'u', '7'
;       * , ?, ?,  < ,  K ,  I ,  O ,  ) ,  ( , ?, ?,  > ,  ? ,  L ,  : ,  P
db    '8', 0, 0, ',', 'k', 'i', 'o', '0', '9', 0, 0, '.', '/', 'l', ';', 'p'
;       _ , ?, ?, ?,  " , ?,  { ,  + , ?, ?,Caps,Rshf,Entr,  } , ?,  | 
db    '-', 0, 0, 0, 39 ,  0,  '[',  '=', 0, 0,  0 ,  0 ,  1 , ']', 0,  92
;       ?, ?, ?, ?, ?, ?, ?, ?,BkSp, ?, ?,  1 , ?,  4 ,  7 , ?, ?, ?,  0
db     0, 0, 0, 0, 0, 0, 0, 0,  1 , 0, 0, '1', 0, '4', '7', 0, 0, 0, '0'
;       . ,  2 ,  5 ,  6 ,  8 , ESC,Numl, F11,  + ,  3 ,  - ,  * ,  9 ,Scrl
db    '.', '2', '5', '6', '8',  1 ,  0 ,  1 , '+', '3', '-', '*', '9',  0 
;       ?, ?, ?, ?,  F7
db     0, 0, 0, 0,  1

KbScanCodes2:
; Keyboard Scancodes with shift
;       ?,  F9, ?,  F5,  F4,  F1,  F2, F12, ?, F10,  F8,  F6,  F4, TAB,  ~
db     0,  2 , 0,  2 ,  2 ,  2 ,  2 ,  2 , 0,  2 ,  2 ,  2 ,  2 ,  2 , '`'
;       ?, ?,Lalt,Lshf, ?,Lctr,  Q ,  ! , ?, ?, ?,  Z ,  S ,  A ,  W ,  @
db     0, 0,  0 ,  0 , 0,  0 , 'Q', '!', 0, 0, 0, 'Z', 'S', 'A', 'W', '@'
;       ?, ?,  C ,  X ,  D ,  E ,  $ ,  # , ?, ?, " ",  V ,  F ,  T ,  R
db     0, 0, 'C', 'X', 'D', 'E', '$', '#', 0, 0, ' ', 'V', 'F', 'T', 'R'
;       % , ?, ?,  N ,  B ,  H ,  G ,  Y ,  ^ , ?, ?, ?,  M ,  J ,  U ,  &
db    '%', 0, 0, 'N', 'B', 'H', 'G', 'Y', '^', 0, 0, 0, 'M', 'J', 'U', '&'
;       * , ?, ?,  < ,  K ,  I ,  O ,  ) ,  ( , ?, ?,  > ,  ? ,  L ,  : ,  P
db    '*', 0, 0, '<', 'K', 'I', 'O', ')', '(', 0, 0, '>', '?', 'L', ':', 'P'
;       _ , ?, ?, ?,  " , ?,  { ,  + , ?, ?,Caps,Rshf,Entr,  } , ?,  | 
db    '_', 0, 0, 0, '"', 0, '{', '+', 0, 0,  0 ,  0 ,  2 , '}', 0, '|'
;       ?, ?, ?, ?, ?, ?, ?, ?,BkSp, ?, ?,  1 , ?,  4 ,  7 , ?, ?, ?,  0
db     0, 0, 0, 0, 0, 0, 0, 0,  2 , 0, 0, '1', 0, '4', '7', 0, 0, 0, '0'
;       . ,  2 ,  5 ,  6 ,  8 , ESC,Numl, F11,  + ,  3 ,  - ,  * ,  9 ,Scrl
db    '.', '2', '5', '6', '8',  2 ,  0 ,  2 , '+', '3', '-', '*', '9',  0
;       ?, ?, ?, ?,  F7
db     0, 0, 0, 0,  2

	END 


 
